package org.xtext.example.mydsl.validation;

import java.io.IOException;
import java.lang.reflect.Method;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.xtext.validation.Check;
import org.eclipse.xtext.validation.CheckType;
import org.xtext.example.mydsl.MyDslStandaloneSetup;
import org.xtext.example.mydsl.myDsl.MyDslPackage;
import org.xtext.example.mydsl.myDsl.impl.ModelImpl;

import com.google.inject.Injector;

import epsilon.transfo.etl.EtlStandalone;




public class MyDslETLLauncher {

	@Check(CheckType.EXPENSIVE)
	public void validate(ModelImpl model) {
		
		System.out.println("Validation launched");
		System.out.println("model : " + model);
		
//		LaresDslParamPackage
		
		
		String paramModelURI = model.eResource().getURI().toString();
		System.out.println("paramModelURI : " + paramModelURI);

		System.out.println("path : " + model.eResource().getURI().path());
		paramModelURI = paramModelURI.replace("/src/", "/src-gen/");
		paramModelURI = paramModelURI.substring(0, paramModelURI.length() - 4);
		String basicModelURI = paramModelURI + "_basic.xmi";
		paramModelURI = paramModelURI + ".xmi";

		System.out.println("myURI : " + paramModelURI); 
		System.out.println("basicModelURI : " + basicModelURI);
		
		Injector injector = new MyDslStandaloneSetup().createInjectorAndDoEMFRegistration();
		ResourceSet set = injector.getInstance(ResourceSet.class);
		Resource paramResource = set.createResource(URI.createURI(paramModelURI));
		
		paramResource.getContents().add(model);
		
		try {
			paramResource.save(null);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
		runTransformation(model, paramModelURI, basicModelURI);
		
		
	}
	
	public void runTransformation(ModelImpl paramModel, String URIIn, String URIOut) {
		System.out.println("starting transformation");

		try {
			// creating an empty resource to store the basic file
			Injector injector = new MyDslStandaloneSetup().createInjectorAndDoEMFRegistration();
			ResourceSet set = injector.getInstance(ResourceSet.class);
			Resource basicResource = set.createResource(URI.createURI(URIOut));

			
			System.out.println("creating EtlStandalone");
			EtlStandalone transformer = new EtlStandalone(paramModel, basicResource,MyDslPackage.eNS_URI);
//			transformer.execute();
			
			
			Method execute = null;
			for (Method method : transformer.getClass().getMethods()) {
				System.out.println(method.getName());
				if (method.getName().equals("execute")) {
					execute = method;
					break;
				}
			}
			execute.setAccessible(true);
			try {
				execute.invoke(transformer);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			System.out.println("End of Basic generation.");
			basicResource.save(null);
			

		} catch (Exception e1) {
			System.out.println("error while generating basic : ");
			
			e1.printStackTrace();
		}

	}

}
